<?php

/**
 * Copyright © 2017 Filoblu S.r.l. All rights reserved.
 */

namespace FiloBlu\GaMeasurementProtocol\Model\Observer;

/*
 * Load Ga Session Id  when getting Order by OrderRepository 
 */

use Magento\Framework\Event\Observer as EventObserver;
use Magento\Framework\Event\ObserverInterface;

class QuoteToOrderGaSessionIdObserver implements ObserverInterface {

    /**
     * @var \Magento\Framework\ObjectManagerInterface
     */
    protected $_objectManager;

    /**
     * @param \Magento\Framework\ObjectManagerInterface $objectmanager
     */
    public function __construct(\Magento\Framework\ObjectManagerInterface $objectmanager) {
        $this->_objectManager = $objectmanager;
    }

    public function execute(EventObserver $observer) {
        $order = $observer->getOrder();
        $quoteRepository = $this->_objectManager->create('Magento\Quote\Model\QuoteRepository');
        /** @var \Magento\Quote\Model\Quote $quote */
        $quote = $quoteRepository->get($order->getQuoteId());
        $order->setGaSessionId($quote->getGaSessionId());

        return $this;
    }

}
